/* ------------------------------------------------------ */
/*                     GRAPH.C                            */
/* stellt fest, ob GRAPHICS.COM geladen wurde.            */
/* Returncode : 1 -> GRAPHICS.COM geladen                 */
/*              0 -> GRAPHICS.COM nicht geladen           */
/*              3 -> falsche DOS-Version                  */
/*         (c) 1992 Michael Winter & DMV-Verlag           */
/* ------------------------------------------------------ */

#include <stdio.h>
#include <dos.h>
#include <stdlib.h>

/* --- Funktionsprototypen ------------------------------ */

int main( void );
int graphics( void );
int dr_dos();

/* --- Programm ----------------------------------------- */

int main( void )
{
  printf("\n\n");
  printf("GRAPH - (c) 1992 Michael Winter & DMV-Verlag");

  if ( ( _osmajor < 3 ) || dr_dos() )
  {
    printf("\n\n");
    printf("Mindestens MS-/PC-DOS 3.0 erforderlich!\n\n");
    exit(3);
  }

  printf("\n\nGRAPHICS.COM ");

  if ( graphics() )
  {
    printf("installiert\n\n");
    exit(1);
  }
  else
  {
    printf("nicht installiert\n\n");
    exit(0);
  }
}

int graphics( void )
{
  union REGS regs;

  if ( ( _osmajor == 4 ) && ( _osminor == 0 ) )
    regs.x.ax = 0x1500;
  else
    regs.x.ax = 0xAC00;

  int86( 0x2F, &regs, &regs );

  if ( regs.x.ax == 0xFFFF )
    return(1);
  else
    return(0);
}

int dr_dos()
{
  union REGS regs;

  regs.x.ax = 0x4452;
  intdos( &regs, &regs );
  return !regs.x.cflag;
}
/* ------------------------------------------------------ */
/*                   Ende von GRAPH.C                     */
