/* ------------------------------------------------------ */
/*                    ISSHARE.C                           */
/*         stellt fest, ob SHARE.EXE geladen wurde.       */
/*     Returncode : 1 -> SHARE.EXE geladen                */
/*                  0 -> SHARE.EXE nicht geladen          */
/*                  3 -> falsche DOS-Version              */
/*            (c) 1992 Michael Winter & DMV-Verlag        */
/* ------------------------------------------------------ */

#include <stdio.h>
#include <dos.h>
#include <stdlib.h>

/* --- Funktionsprototypen ------------------------------ */

int main( void );
int share( void );
int dr_dos();

/* --- Programm ----------------------------------------- */

int main( void )
{
  printf("\n\n");
  printf("ISSHARE - (c) 1992 Michael Winter & DMV-Verlag");

  if ( ( _osmajor < 4 ) || dr_dos() )
  {
    printf("\n\n");
    printf("Mindestens MS-/PC-DOS 4.0 erforderlich!\n\n");
    exit(3);
  }

  printf("\n\nSHARE.EXE ");

  if ( share() )
  {
    printf("installiert\n\n");
    exit(1);
  }
  else
  {
    printf("nicht installiert\n\n");
    exit(0);
  }
}

int share( void )
{
  union REGS regs;

  regs.x.ax = 0x1000;

  int86( 0x2F, &regs, &regs );

  if ( regs.h.al == 0xFF )
    return(1);
  else
    return(0);

}

int dr_dos()
{
  union REGS regs;

  regs.x.ax = 0x4452;
  intdos( &regs, &regs );
  return !regs.x.cflag;
}
/* ------------------------------------------------------ */
/*                    Ende von ISSHARE.C                  */
