/* ------------------------------------------------------ */
/*                      INT13.C                           */
/*              (c) 1991 Borland International            */
/*                   All rights reserved.                 */
/* ------------------------------------------------------ */
/*            verffentlicht in DOS toolbox 3'92          */
/* ------------------------------------------------------ */


void interrupt (*Old13Handler)();

unsigned Int13BusyFlag = 0x00;

void interrupt New13Handler(
  unsigned bp, unsigned di, unsigned si,
  unsigned ds, unsigned es, unsigned dx,
  unsigned cx, unsigned bx, unsigned ax,
  unsigned ip, unsigned cs, unsigned flags)
{
  Int13BusyFlag++;    // Increment the Int13BusyFlag
  (*Old13Handler)();  // Call old handler
  ax    = _AX;        // Return values
  bx    = _BX;
  cx    = _CX;
  dx    = _DX;
  es    = _ES;
  di    = _DI;
  flags = _FLAGS;
  --Int13BusyFlag;    // Restore the Int13BusyFlag
}
/* ------------------------------------------------------ */
/*                  Ende von INT13.C                      */
