PROCEDURE DemoDialogDialog;
  TYPE
    DemoDialogData = RECORD
      String0: STRING [80];
      String1: STRING [80];
      String2: STRING [80];
      String3: STRING [80];
      TextLen0: WORD;
      TextRec0: ARRAY [0..512] OF CHAR; 
      Cluster0: WORD;
      Cluster1: WORD;
    END;
  
  VAR
    R: tRect;
    View: pView;
    Data: DemoDialogData;
    Code: INTEGER;
    Dialog: pDialog;
BEGIN
  R.Assign (3, 0, 75, 22);
  Dialog := New (pDialog, Init (R, 'Demo Dialog'));
  Dialog^.State := 2171;
 
  R.Assign (3, 2, 69, 3);
  Dialog^.Insert (New (pStaticText, Init (R, 'Dies ist ein Demo-Dialog, der vollstndig mit TOOL erstellt wurde.')));
 
  R.Assign (3, 4, 58, 5);
  Dialog^.Insert (New (pStaticText, Init (R, 'Bitte fllen Sie folgendes Registrierungs-Formular aus:')));
 
  R.Assign (12, 6, 32, 7);
  View := New (pInputLine, Init (R, 80));
  Dialog^.Insert (View);
  R.Assign (2, 6, 8, 7);
  Dialog^.Insert (New (pLabel, Init (R, 'Name:', View)));
  R.Assign (32, 6, 35, 7);
  Dialog^.Insert (New (pHistory, Init  (R, pInputLine (View), 0)));
 
  R.Assign (46, 6, 66, 7);
  View := New (pInputLine, Init (R, 80));
  Dialog^.Insert (View);
  R.Assign (36, 6, 46, 7);
  Dialog^.Insert (New (pLabel, Init (R, 'Vorname: ', View)));
  R.Assign (66, 6, 69, 7);
  Dialog^.Insert (New (pHistory, Init  (R, pInputLine (View), 0)));
 
  R.Assign (12, 7, 32, 8);
  View := New (pInputLine, Init (R, 80));
  Dialog^.Insert (View);
  R.Assign (2, 7, 12, 8);
  Dialog^.Insert (New (pLabel, Init (R, 'Strasse: ', View)));
  R.Assign (32, 7, 35, 8);
  Dialog^.Insert (New (pHistory, Init  (R, pInputLine (View), 0)));
 
  R.Assign (46, 7, 66, 8);
  View := New (pInputLine, Init (R, 80));
  Dialog^.Insert (View);
  R.Assign (36, 7, 46, 8);
  Dialog^.Insert (New (pLabel, Init (R, 'PLZ/Ort: ', View)));
  R.Assign (66, 7, 69, 8);
  Dialog^.Insert (New (pHistory, Init  (R, pInputLine (View), 0)));
 
  R.Assign (30, 10, 31, 17);
  View := New (pScrollBar, Init  (R)); 
  Dialog^.Insert (View); 
  pScrollBar (View)^.SetRange (0, 0); 
  R.Assign (3, 10, 30, 17);
  View := New (pMemo, Init (R, NIL, pScrollBar (View), NIL, 512));
  Dialog^.Insert (View);
  R.Assign (3, 9, 27, 10);
  Dialog^.Insert (New (pLabel, Init (R, 'Kurzkommentar zu TOOL: ', View)));
 
  R.Assign (39, 10, 54, 13);
  View := New (pRadioButtons,
               Init (R, 
                     NewSItem ('Sehr oft',
                     NewSItem ('Oft',
                     NewSItem ('Seltener',
                     NIL)))));
  Dialog^.Insert (View);
  R.Assign (39, 9, 53, 10);
  Dialog^.Insert (New (pLabel, Init (R, 'Benutzung ...', View)));
 
  R.Assign (39, 15, 54, 17);
  View := New (pRadioButtons,
               Init (R, 
                     NewSItem ('Per Check',
                     NewSItem ('Rechnung',
                     NIL))));
  Dialog^.Insert (View);
  R.Assign (39, 14, 50, 15);
  Dialog^.Insert (New (pLabel, Init (R, 'Bezahlung:', View)));
 
  R.Assign (5, 19, 23, 21);
  Dialog^.Insert (New (pButton, Init (R, '~R~egistrieren', 10, 1)));
 
  R.Assign (31, 19, 42, 21);
  Dialog^.Insert (New (pButton, Init (R, '~H~ilfe', 9, 0)));
 
  R.Assign (49, 19, 64, 21);
  Dialog^.Insert (New (pButton, Init (R, '~A~bbrechen', 11, 0)));
 
  Dialog^.SelectNext (FALSE);
 
    { Datenrecord initialisieren ! }
  FillChar (Data, SizeOf (DemoDialogData), 0);
  Dialog^.SetData (Data); 
  Code := Desktop^.ExecView (Application^.ValidView (Dialog));
  IF Code <> cmCancel THEN BEGIN
    { cmCancel muss ev ersetzt werden }
    { Code auswerten }
    Dialog^.GetData (Data);
    { Data muss ausgewertet werden ! }
  END;
  IF Dialog <> NIL THEN 
    Dispose (Dialog, Done);
END;
